<h1 align="center">
  <b>Awesome Hacker Search Engines</b>
</h1>

<p align="center">
A list of search engines useful during Penetration testing, vulnerability assessments, red team operations, bug bounty and more
</p>

<p align="center">
  <a href="#general-search-engines" target="_blank">General</a> •
  <a href="#servers" target="_blank">Servers</a> •
  <a href="#vulnerabilities" target="_blank">Vulnerabilities</a> •
  <a href="#exploits" target="_blank">Exploits</a> •
  <a href="#attack-surface" target="_blank">Attack surface</a> •
  <a href="#code-search-engines" target="_blank">Code</a> •
  <a href="#mail-addresses" target="_blank">Mail addresses</a> •
  <a href="#domains" target="_blank">Domains</a> •
  <a href="#urls" target="_blank">URLs</a> •
  <a href="#dns" target="_blank">DNS</a> •
  <a href="#certificates" target="_blank">Certificates</a> •
  <a href="#wifi-networks" target="_blank">WiFi networks</a> •
  <a href="#credentials" target="_blank">Credentials</a> •
  <a href="#social-networks" target="_blank">Social Networks</a> •
  <a href="#phone-numbers" target="_blank">Phone numbers</a> •
  <a href="#threat-intelligence" target="_blank">Threat Intelligence</a> •
  <a href="#web-history" target="_blank">Web History</a>
</p>

### General Search Engines
- [Google](https://www.google.com/)
- [Bing](https://www.bing.com/)
- [Yahoo!](http://www.yahoo.com/)
- [Yandex](https://yandex.com/)


### Servers
- [Shodan](https://shodan.io) - Search Engine for the Internet of Everything
- [Onyphe.io](https://www.onyphe.io/) - Cyber Defense Search Engine for open-source and cyber threat intelligence data
- [ZoomEye](https://www.zoomeye.org/) - Global cyberspace mapping
- [GreyNoise](https://viz.greynoise.io/) - The source for understanding internet noise
- [Natlas](https://natlas.io/)
- [FOFA](https://fofa.info/)

### Vulnerabilities
- [NIST NVD](https://nvd.nist.gov/vuln/search) - National Vulnerability Database
- [MITRE CVE](https://cve.mitre.org/cve/search_cve_list.html) - Identify, define, and catalog publicly disclosed cybersecurity vulnerabilities
- [osv.dev](https://osv.dev/list) - Open Source Vulnerabilities
- [cloudvulndb.org](https://www.cloudvulndb.org/) - The Open Cloud Vulnerability & Security Issue Database
- [Vulners.com](https://vulners.com/) - Your Search Engine for Security Intelligence
- [opencve.io](https://www.opencve.io/cve) - Easiest way to track CVE updates and be alerted about new vulnerabilities
- [security.snyk.io](https://security.snyk.io/) - Open Source Vulnerability Database
- [Rapid7 - DB](https://www.rapid7.com/db/) - Vulnerability & Exploit Database
- [CVEDetails](https://www.cvedetails.com/) - The ultimate security vulnerability datasource
- [VulnIQ](https://vulniq.com/)
- [SynapsInt](https://synapsint.com/) - The unified OSINT research tool
- [Aqua Vulnerability Database](https://avd.aquasec.com/) - Vulnerabilities and weaknesses in open source applications and cloud native infrastructure


### Exploits
- [Exploit-DB](https://www.exploit-db.com/) - Exploit Database
- [Sploitus](https://sploitus.com/) - Convenient central place for identifying the newest exploits
- [Rapid7 - DB](https://www.rapid7.com/db/) - Vulnerability & Exploit Database


### Attack Surface
- [FullHunt.io](https://fullhunt.io/) - Attack surface database of the entire Internet
- [BynaryEdge](https://www.binaryedge.io/) - We scan the web and gather data for you
- [Censys](https://censys.io/) - Attack Surface Management Solutions
- [RedHunt Labs](https://redhuntlabs.com/) - Discover your Attack Surface, Continuously
- [SecurityTrails](https://securitytrails.com/) - The Total Internet Inventory
- [criminalip.io](https://www.criminalip.io/) - Cyber Threat Intelligence Search Engine and Attack Surface Management(ASM) platform


### Code Search Engines
- [GitHub Code Search](https://cs.github.com/)
- [grep.app](https://grep.app/) - Search across a half million git repos
- [publicwww.com](https://publicwww.com/) - Find any alphanumeric snippet, signature or keyword in the web pages HTML, JS and CSS code
- [SearchCode](https://searchcode.com/) - Search 75 billion lines of code from 40 million projects
- [NerdyData](https://www.nerdydata.com/) - Find companies based on their website's tech stack or code
- [RepoSearch](http://codefinder.org/) - Source code search engine that helps you find implementation details, example usages or just analyze code


### Mail addresses
- [Hunter.io](https://hunter.io/) - Find professional email addresses in seconds
- [PhoneBook](https://phonebook.cz/) - Lists all domains, email addresses, or URLs for the given input domain
- [IntelligenceX](https://intelx.io/) - Search engine and data archive
- [Reacher.email](https://reacher.email/) - Open-Source Email Verification
- [RocketReach](https://rocketreach.co/)
- [email-format.com](https://www.email-format.com/) - Find the email address formats in use at thousands of companies
- [EmailHippo](https://tools.emailhippo.com/) - Email address verification technology
- [ThatsThem](https://thatsthem.com/reverse-email-lookup) - Reverse email lookup
- [verify-email.org](https://verify-email.org/)
- [Melissa - Emailcheck](https://www.melissa.com/v2/lookups/emailcheck/email/)
- [VoilaNorbert](https://www.voilanorbert.com/) - I can find anyone's email address
- [SynapsInt](https://synapsint.com/) - The unified OSINT research tool
- [skymem.info](http://www.skymem.info/) - Find email addresses of companies and people


### Domains
- [PhoneBook](https://phonebook.cz/) - Lists all domains, email addresses, or URLs for the given input domain
- [IntelligenceX](https://intelx.io/) - Search engine and data archive
- [Omnisint](https://omnisint.io/subdomain-enumeration) - Subdomain enumeration
- [Riddler](https://riddler.io/) - Allows you to search in a high quality dataset
- [RobTex](https://www.robtex.com/) - Various kinds of research of IP numbers, Domain names, etc
- [CentralOps - DomainDossier](https://centralops.net/co/DomainDossier.aspx)
- [DomainIQ](https://www.domainiq.com/)
- [whois.domaintools.com](https://whois.domaintools.com/)
- [grayhatwarfare.com - domains](https://shorteners.grayhatwarfare.com/domains)
- [whoisology.com](https://whoisology.com/)
- [who.is](https://who.is/)
- [pentest-tools.com](https://pentest-tools.com/information-gathering/find-subdomains-of-domain)
- [BuiltWith](https://builtwith.com/)
- [MoonSearch](http://moonsearch.com/)
- [sitereport.netcraft.com](https://sitereport.netcraft.com/)
- [SynapsInt](https://synapsint.com/)
- [statscrop.com](https://www.statscrop.com/)
- [securityheaders.com](https://securityheaders.com/)
- [visualsitemapper.com](http://www.visualsitemapper.com/)
- [similarweb.com](https://www.similarweb.com/)
- [buckets.grayhatwarfare.com](https://buckets.grayhatwarfare.com/) - Public buckets
- [C99.nl](https://api.c99.nl/)


### URLs
- [PhoneBook](https://phonebook.cz/)
- [IntelligenceX](https://intelx.io/)
- [URLScan](https://urlscan.io/)
- [HackerTarget](https://hackertarget.com/ip-tools/)
- [MOZ Link Explorer](https://moz.com/link-explorer)
- [spyonweb.com](https://spyonweb.com/)
- [shorteners.grayhatwarfare.com](https://shorteners.grayhatwarfare.com/)


### DNS
- [DNSDumpster](https://dnsdumpster.com/)
- [RapidDNS](https://rapiddns.io/)
- [DNSdb](https://docs.farsightsecurity.com/#dnsdb)
- [Omnisint](https://omnisint.io/reverse-dns-lookup) - Reverse DNS lookup
- [HackerTarget](https://hackertarget.com/ip-tools/)
- [passivedns.mnemonic.no](https://passivedns.mnemonic.no/)
- [ptrarchive.com](http://ptrarchive.com/)
- [dnshistory.org](http://dnshistory.org/)
- [DNSTwister](https://dnstwister.report/)
- [DNSviz](https://dnsviz.net/)
- [C99.nl](https://api.c99.nl/)


### Certificates
- [Crt.sh](https://crt.sh/)
- [CTSearch](https://ui.ctsearch.entrust.com/ui/ctsearchui)
- [TLS.BufferOver.run](https://tls.bufferover.run/)
- [CertSpotter](https://sslmate.com/certspotter/)
- [SynapsInt](https://synapsint.com/)
- [Censys - Certificates](https://search.censys.io/certificates)


### WiFi networks
- [Wigle.net](https://wigle.net/)


### Credentials
- [Have I Been Pwned](https://haveibeenpwned.com/)
- [Dehashed](https://www.dehashed.com/)
- [Leak-Lookup](https://leak-lookup.com/)
- [Snusbase](https://snusbase.com/)
- [LeakCheck.io](https://leakcheck.io/)
- [crackstation.net](https://crackstation.net/)
- [breachdirectory.org](https://breachdirectory.org/)


### Social Networks

These can be useful for osint and social engineering.

- [Facebook](https://www.facebook.com/)
- [Instagram](https://www.instagram.com/)
- [YouTube](https://www.youtube.com/)
- [Twitter](https://twitter.com/)
- [LinkedIn](https://www.linkedin.com/)
- [Reddit](https://new.reddit.com/)
- [Pinterest](https://www.pinterest.com/)
- [Tumblr](https://www.tumblr.com/)
- [Flickr](https://www.flickr.com/)
- [SnapChat](https://www.snapchat.com/)
- [Whatsapp](https://www.whatsapp.com/)
- [Quora](https://www.quora.com/)
- [TikTok](https://www.tiktok.com/)
- [Vimeo](https://vimeo.com/)
- [Medium](https://medium.com/)
- [WeChat](https://www.wechat.com/)
- [VK](https://vk.com/)
- [Weibo](https://weibo.com/)
- [Tinder](https://tinder.com/)


### Phone numbers
- [RocketReach](https://rocketreach.co/)
- [NumLookup](https://www.numlookup.com/)
- [WhitePages](https://www.whitepages.com/)
- [National Cellular Directory](https://www.nationalcellulardirectory.com/)
- [Phone Validator](https://www.phonevalidator.com/)
- [Free Carrier Lookup](https://freecarrierlookup.com/)
- [sync.me](https://sync.me/)
- [EmobileTracker](https://www.emobiletracker.com/)
- [SpyDialer](https://spydialer.com/)
- [Reverse Phone Lookup](https://www.reversephonelookup.com/)
- [ThatsThem](https://thatsthem.com/reverse-phone-lookup) - Reverse phone lookup
- [thisnumber.com](https://www.thisnumber.com/)
- [usphonebook.com](https://www.usphonebook.com/)
- [truecaller.com](https://www.truecaller.com/)
- [truepeoplesearch.com](https://www.truepeoplesearch.com/#)
- [SynapsInt](https://synapsint.com/)
- [C99.nl](https://api.c99.nl/)


### Threat Intelligence
- [PulseDive](https://pulsedive.com/)
- [ThreatCrowd](https://threatcrowd.org/)
- [ThreatMiner](https://www.threatminer.org/)
- [VirusTotal](https://www.virustotal.com/)
- [Rescure](https://rescure.me/)
- [otx.alienvault](https://otx.alienvault.com/)
- [urlquery.net](https://urlquery.net/)
- [bazaar.abuse.ch](https://bazaar.abuse.ch/browse/)
- [feodotracker.abuse.ch](https://feodotracker.abuse.ch/browse/)
- [sslbl.abuse.ch](https://sslbl.abuse.ch/ssl-certificates/)
- [urlhaus.abuse.ch](https://urlhaus.abuse.ch/browse/)
- [threatfox.abuse.ch](https://threatfox.abuse.ch/browse/)


### Web History
- [Web Archive](https://web.archive.org/)
- [Archive.ph](https://archive.ph/)
- [CachedPages](http://www.cachedpages.com/)
- [stored.website](https://stored.website/)
- [CommonCrawl](https://commoncrawl.org/)


### Unclassified
- [Spyse](https://spyse.com/)
- [NetoGraph](https://netograph.io/)
- [DNS.BufferOver.run](https://dns.bufferover.run/)
- [Chaos](https://chaos.projectdiscovery.io/#/)
- [PassiveTotal](https://api.passivetotal.org/)

---------

# Source:
  - [Awesome Hacker Search Engines](https://github.com/edoardottt/awesome-hacker-search-engines/blob/main/README.md)
